package me.Demon.AskyBlockWarps.Listener;

import cn.hamster3.cdapi.CDTimeAPI;
import com.wasteofplastic.askyblock.ASkyBlockAPI;
import de.tr7zw.itemnbtapi.NBTItem;
import me.Demon.AskyBlockWarps.Main;
import me.Demon.AskyBlockWarps.Util.itemUtil;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class LandInviteGui implements Listener {
    public static String invtitle = "帝国战争 - 成员邀请";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getInventory() != null && e.getInventory().getTitle().contains(invtitle)) {
            e.setCancelled(true);
            if (e.getRawSlot() >= 0 && e.getRawSlot() < e.getInventory().getSize()) {
                ItemStack item = e.getCurrentItem();
                if(!DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)) {
                    NBTItem nbtItem = new NBTItem(item);
                    if (nbtItem.hasKey("inviteName")) {
                        p.closeInventory();
                        String name = nbtItem.getString("inviteName");
                        p.performCommand("is invite " + name);
                        Player toPlayer = Bukkit.getPlayer(name);
                        if(CDTimeAPI.getCD(p.getUniqueId(),"inviteCd") > 0){
                            return;
                        }
                        if(toPlayer != null){
                            AcceptGui.Opengui(toPlayer);
                            CDTimeAPI.setPlayerCD(p.getUniqueId(),"inviteCd",1000 * 10);
                        }
                    }
                }
            }
        }
    }

    public static void Opengui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 54, invtitle);
        // 获取玩家附近20格内的所有玩家
        List<Player> nearbyPlayers = new ArrayList<>();
        World world = p.getWorld();
        for (Player nearbyPlayer : world.getPlayers()) {
            if (p.getLocation().distance(nearbyPlayer.getLocation()) <= 50) {
                // 判断这个玩家是否已加入岛屿
                if(!ASkyBlockAPI.getInstance().hasIsland(nearbyPlayer.getUniqueId())) {
                    nearbyPlayers.add(nearbyPlayer);
                }
            }
        }
        if(nearbyPlayers.size() < 1){
            p.sendMessage(Main.prefix + "您周围没有玩家可邀请加入岛屿.");
            p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1.6F, 1.8F);
            return;
        }
        for (Player nearbyPlayer : nearbyPlayers) {
            if (!p.equals(nearbyPlayer)) { // 避免将玩家自己添加到GUI中
                inv.addItem(addTeam(nearbyPlayer.getName()));
            }
        }

        p.openInventory(inv);
    }

    public static ItemStack addTeam(String name) {
        ItemStack item = new ItemStack(Material.SIGN);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l玩家 §e" + name);
        List<String> lore = new ArrayList<>();
        lore.add("§r");
        lore.add("§c 请勿随意点击");
        lore.add("§c 请勿随意点击");
        lore.add("§c 请勿随意点击");
        lore.add("§r");
        lore.add("§6▸ §e点击邀请加入岛屿");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTItem nbtItem = new NBTItem(item);
        nbtItem.setString("inviteName",name);
        return nbtItem.getItem();
    }
}
