package me.Demon.AskyBlockWarps.Listener;

import com.wasteofplastic.askyblock.ASkyBlockAPI;
import com.wasteofplastic.askyblock.Island;
import com.yaohun.playermanage.PlayerManage;
import de.tr7zw.itemnbtapi.NBTItem;
import me.Demon.AskyBlockWarps.Main;
import me.Demon.AskyBlockWarps.Util.itemUtil;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class LandTeamGui implements Listener {
    public static String invtitle = "帝国战争 - 空岛成员";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        int rawSlot = e.getRawSlot();
        Inventory inv = e.getInventory();
        Player p = (Player) e.getWhoClicked();
        Location location = p.getLocation();
        String name = p.getName();
        if (inv != null && inv.getTitle().contains(invtitle)) {
            e.setCancelled(true);
            ItemStack item = e.getCurrentItem();
            if (rawSlot >= 0 && rawSlot < inv.getSize()) {
                if(!DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)) {
                    NBTItem nbtItem = new NBTItem(item);
                    if(nbtItem.hasKey("uuid")) {
                        String uuid = nbtItem.getString("uuid");
                        // 获取当前岛屿数据
                        Island island = ASkyBlockAPI.getInstance().getIslandAt(location);
                        UUID ownerUuid = island.getOwner();
                        // 判断操作目标是否是岛屿主人
                        if(ownerUuid.toString().equalsIgnoreCase(uuid)){
                            p.sendMessage(Main.prefix + "无法对岛屿主人进行移除操作.");
                            p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH,1.6F,1.8F);
                            return;
                        }
                        // 判断操作移除的人是否是岛屿主人
                        if(!ownerUuid.equals(p.getUniqueId())){
                            p.sendMessage(Main.prefix + "只有岛屿主人才能进行移除操作.");
                            p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH,1.6F,1.8F);
                            return;
                        }
                        String kickName = PlayerManage.getUuidToName(uuid);
                        if(kickName == null){
                            p.sendMessage(Main.prefix + "移除失败,无法获取该目标昵称.");
                            p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH,1.6F,1.8F);
                            return;
                        }
                        p.performCommand("is expel " + kickName);
                    }
                }
            }
        }
    }

    public static void Opengui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 27, invtitle);
        Island island = ASkyBlockAPI.getInstance().getIslandAt(p.getLocation());
        int slot = 0;
        List<UUID> uuidList = island.getMembers();
        uuidList.remove(0);
        for (UUID uuid : uuidList){
            String name = PlayerManage.getUuidToName(uuid.toString());
            if (name != null) {
                if (!uuid.equals(island.getOwner())) {
                    inv.setItem(slot,teamList(uuid,false));
                }else{
                    inv.setItem(slot,teamList(uuid,true));
                }
                slot++;
            }
        }
        p.openInventory(inv);
    }

    public static ItemStack teamList(UUID uuid,boolean owner) {
        ItemStack item = new ItemStack(Material.SIGN);
        ItemMeta meta = item.getItemMeta();
        String name = PlayerManage.getUuidToName(uuid.toString());
        if(name == null){
            meta.setDisplayName("§6§l成员 §c无法获取");
        }else {
            meta.setDisplayName("§6§l成员 §e" + name);
        }
        List<String> lore = new ArrayList<>();
        lore.add("§r");
        if(owner){
            lore.add("§7 身份: §f岛主");
        }else {
            lore.add("§7 身份: §f岛员");
        }
        lore.add("§r");
        lore.add("§6▸ §c点击移除岛屿");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTItem nbtItem = new NBTItem(item);
        nbtItem.setString("uuid",uuid.toString());
        return nbtItem.getItem();
    }
}
