package me.Demon.AskyBlockWarps.Listener;

import cn.hamster3.cdapi.CDTimeAPI;
import com.wasteofplastic.askyblock.ASkyBlockAPI;
import com.wasteofplastic.askyblock.Island;
import com.yaohun.playermanage.PlayerManage;
import lk.vexview.api.VexViewAPI;
import me.Demon.AskyBlockWarps.Main;
import me.Demon.AskyBlockWarps.Manage.GameManage;
import me.Demon.AskyBlockWarps.Util.itemUtil;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.entity.Vex;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class MainGui implements Listener {
    public static String invtitle = "帝国战争 - 空岛管理";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        int rawSlot = e.getRawSlot();
        Inventory inv = e.getInventory();
        Player p = (Player) e.getWhoClicked();
        Location location = p.getLocation();
        String name = p.getName();
        if (inv != null && inv.getTitle().contains(invtitle)) {
            e.setCancelled(true);
            if (rawSlot >= 0 && rawSlot < inv.getSize()) {
                ItemStack item = e.getCurrentItem();
                if(DemonAPI.itemIsNull(item) || DemonAPI.itemIsName(item)){return;}
                ItemMeta meta = item.getItemMeta();
                String itemName = meta.getDisplayName();
                if(itemName.contains("返回主页")){
                    VexViewAPI.openGui(p,"主菜单");
                    p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1.6F, 1.8F);
                    return;
                }
                if(itemName.contains("返回空岛")){
                    p.performCommand("is");
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.0F, 2.0F);
                    p.closeInventory();
                    return;
                }
                if(itemName.contains("空岛地标列表")){
                    WarpGui.Opengui(p);
                    p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1.6F, 1.8F);
                    return;
                }
                if(itemName.contains("邀请加入空岛")){
                    // 判断玩家是否拥有岛屿并且是岛主
                    boolean isOwner = false;
                    Island island = ASkyBlockAPI.getInstance().getIslandOwnedBy(p.getUniqueId());
                    if(island != null){
                        UUID ownerUuid = island.getOwner();
                        if(ownerUuid.equals(p.getUniqueId())){
                            LandInviteGui.Opengui(p);
                            p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1.6F, 1.8F);
                            isOwner = true;
                        }
                    }
                    if(!isOwner){
                        p.sendMessage(Main.prefix + "您需要创建岛屿成为岛主后才能邀请玩家.");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1.6F, 1.8F);
                    }
                    return;
                }
                if(itemName.contains("设置空岛地标")){
                    p.closeInventory();
                    // 获取当前岛屿岛主UUID
                    Island island = ASkyBlockAPI.getInstance().getIslandAt(location);
                    if(island != null && !island.getOwner().equals(p.getUniqueId())){
                        p.sendMessage(Main.prefix + "您只能在自己的岛屿设置传送点坐标.");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1.6F, 1.8F);
                        return;
                    }
                    if (CDTimeAPI.getCD(p.getUniqueId(), "islandsetwarp") > 0) {
                        p.sendMessage(Main.prefix + "请稍后再次尝试设置坐标.");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1.6F, 1.8F);
                        return;
                    }
                    if(!p.hasPermission("warps.create")){
                        p.sendMessage(Main.prefix + "你需要成为 盫 §r才能设置坐标.");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1.6F, 1.8F);
                        return;
                    }
                    Main.gameManage.setWarpLoc(name,p.getLocation());
                    p.sendMessage(Main.prefix + "设置空岛地标点成功.");
                    CDTimeAPI.setPlayerCD(p.getUniqueId(), "islandsetwarp", 1000 * 5);
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.6F, 1.8F);
                    return;
                }
                if(itemName.contains("重置空岛")){
                    p.closeInventory();
                    DemonAPI.sendTitle(p, 10, 20, 10, "§c§l空岛重置", "§6请联系群客服进行重置");
                    p.sendMessage(Main.prefix + "需要重置岛屿，请联系群内客服申请报备！！！");
                    p.sendMessage(Main.prefix + "需要重置岛屿，请联系群内客服申请报备！！！");
                    p.sendMessage(Main.prefix + "需要重置岛屿，请联系群内客服申请报备！！！");
                    p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1.6F, 1.8F);
                    return;
                }
                if(itemName.contains("岛屿等级")){
                    p.closeInventory();
                    p.performCommand("is level");
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.6F, 1.8F);
                    return;
                }
                if(itemName.contains("岛屿保护")){
                    p.closeInventory();
                    // 获取当前岛屿岛主UUID
                    Island island = ASkyBlockAPI.getInstance().getIslandAt(location);
                    if(island != null && !island.getOwner().equals(p.getUniqueId())){
                        p.sendMessage(Main.prefix + "您只能在自己岛屿上才能设置岛屿保护.");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1.6F, 1.8F);
                        return;
                    }
                    Bukkit.dispatchCommand(Bukkit.getConsoleSender(), "asadmin lock " + p.getName());
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1.6F, 1.8F);
                    return;
                }
                if(itemName.contains("查看空岛成员")){
                    LandTeamGui.Opengui(p);
                    p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1.6F, 1.8F);
                    return;
                }
                if(itemName.contains("挑战任务")){
                    p.performCommand("challenge");
                    p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1.6F, 1.8F);
                    return;
                }
            }
        }
    }

    public static void Opengui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 36, invtitle);
        Island island = ASkyBlockAPI.getInstance().getIslandAt(p.getLocation());
        if (island == null) {
            inv = Bukkit.createInventory(null, 9, invtitle);
            inv.setItem(1, islandBack());
            inv.setItem(3, checkWarpList());
            inv.setItem(5, islandInvite());
            inv.setItem(8,backMenu());
        } else {
            inv.setItem(1, islandBack());
            inv.setItem(3, setWarp());
            inv.setItem(5, checkWarpList());
            inv.setItem(7, resetIsland());
            inv.setItem(11, islandLevel(island));
            inv.setItem(13, islandlock(island));
            inv.setItem(15, islandlook(island));
            inv.setItem(19, islandInvite());
            inv.setItem(25, islandChallenge());
            inv.setItem(31,backMenu());
        }
        p.openInventory(inv);
    }

    public static ItemStack backMenu() {
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§a§l返回主页");
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack islandInvite() {
        ItemStack item = new ItemStack(Material.SLIME_BALL);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l邀请加入空岛");
        List<String> lore = new ArrayList<>();
        lore.add("§r");
        lore.add("§7 自动搜索周围玩家");
        lore.add("§r");
        lore.add("§6▸ §c点击邀请");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack islandBack() {
        ItemStack item = new ItemStack(Material.GRASS);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l返回空岛");
        List<String> lore = new ArrayList<>();
        lore.add("§r");
        lore.add("§6▸ §e点击返回空岛");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack islandChallenge() {
        ItemStack item = new ItemStack(Material.DIAMOND_CHESTPLATE);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l挑战任务");
        List<String> lore = new ArrayList<>();
        lore.add("§r");
        lore.add("§6▸ §e点击查看");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack islandLevel(Island island) {
        ItemStack item = new ItemStack(Material.BEACON);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l岛屿等级");
        List<String> lore = new ArrayList<>();
        lore.add("§r");
        UUID islandOwner = island.getOwner();
        lore.add("§7 岛屿主人: §f" + PlayerManage.getUuidToName(islandOwner.toString()));
        lore.add("§7 岛屿等级: §f" + ASkyBlockAPI.getInstance().getLongIslandLevel(islandOwner));
        lore.add("§r");
        lore.add("§6▸ §e点击刷新岛屿等级");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack islandlook(Island island) {
        ItemStack item = new ItemStack(Material.EMPTY_MAP);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l查看空岛成员");
        List<String> lore = new ArrayList<>();
        lore.add("§r");
        lore.add(" §7岛屿成员:");
        List<UUID> uuidList = island.getMembers();
        uuidList.remove(0);
        for (UUID uuid : uuidList) {
            String name = PlayerManage.getUuidToName(uuid.toString());
            lore.add(" §f - " + name);
        }
        lore.add("§r");
        lore.add("§6▸ §e点击查看");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack islandlock(Island island) {
        ItemStack item = new ItemStack(Material.EYE_OF_ENDER);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l岛屿保护");
        List<String> lore = new ArrayList<>();
        lore.add("§r");
        if(!island.isLocked()){
            lore.add(" §7当前模式: §c封锁中");
        }else {
            lore.add(" §7当前模式: §f开放中");
            item.setType(Material.ENDER_PEARL);
        }
        lore.add("§r");
        lore.add("§6▸ §c点击设置");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack resetIsland() {
        ItemStack item = new ItemStack(Material.LAVA_BUCKET);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l重置空岛");
        List<String> lore = new ArrayList<>();
        lore.add("§r");
        lore.add("§6▸ §c点击重置");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack setWarp() {
        ItemStack item = new ItemStack(Material.ANVIL);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l设置空岛地标");
        List<String> lore = new ArrayList<>();
        lore.add("§r");
        lore.add("§6▸ §e点击设置");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack checkWarpList() {
        ItemStack item = new ItemStack(Material.SIGN);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l空岛地标列表");
        List<String> lore = new ArrayList<>();
        lore.add("§r");
        lore.add(" §7数量: §f"+Main.gameManage.getWarpDataMap().size()+"个");
        lore.add("§r");
        lore.add("§6▸ §e点击查看");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

}
