package me.Demon.AskyBlockWarps.Listener;

import cn.hamster3.cdapi.CDTimeAPI;
import com.wasteofplastic.askyblock.ASkyBlockAPI;
import com.wasteofplastic.askyblock.Island;
import com.yaohun.playermanage.PlayerManage;
import de.tr7zw.itemnbtapi.NBTItem;
import me.Demon.AskyBlockWarps.Data.WarpData;
import me.Demon.AskyBlockWarps.Main;
import me.Demon.AskyBlockWarps.Util.itemUtil;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.UUID;

public class WarpGui implements Listener {
    public static String invtitle = "帝国战争 - 空岛地标";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        int rawSlot = e.getRawSlot();
        Inventory inv = e.getInventory();
        Player p = (Player) e.getWhoClicked();
        String name = p.getName();
        if (e.getInventory() != null && e.getInventory().getTitle().contains(invtitle)) {
            e.setCancelled(true);
            ItemStack item = e.getCurrentItem();
            if (rawSlot >= 0 && rawSlot < inv.getSize()) {
                if(DemonAPI.itemIsNull(item)){return;}
                p.closeInventory();
                p.playSound(p.getLocation(),Sound.BLOCK_COMPARATOR_CLICK,1,1);
                NBTItem nbtItem = new NBTItem(item);
                if(nbtItem.hasKey("warpKey")){
                    boolean butt = nbtItem.getBoolean("warpLock");
                    String warpKey = nbtItem.getString("warpKey");
                    if(butt){
                        p.sendMessage(Main.prefix + "您想访问的目标岛屿处于封锁状态,无法访问.");
                        return;
                    }
                    WarpData warpData = Main.gameManage.getWarpData(warpKey);
                    Location location = warpData.getLocation().add(0,0.5,0);
                    p.teleport(location);
                    p.sendMessage(Main.prefix + "您已传送至 §e" + warpKey + "§f 的空岛地标旁.");
                }
            }
        }
    }

    public static void Opengui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 54, invtitle);
        HashMap<String, WarpData> warpDataHashMap = Main.gameManage.getWarpDataMap();
        for (String key : warpDataHashMap.keySet()){
            WarpData warpData = warpDataHashMap.get(key);
            ItemStack item = warpShow(warpData);
            if(item != null) {
                inv.addItem(item);
            }
        }
        p.openInventory(inv);
    }

    public static ItemStack warpShow(WarpData wData) {
        ItemStack item = new ItemStack(Material.SIGN);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l传送到 §e" + wData.getKey() + " §6§l的空岛");
        List<String> lore = new ArrayList<>();
        Island island = ASkyBlockAPI.getInstance().getIslandAt(wData.getLocation());
        if(island != null) {
            lore.add(" §7岛屿等级: §f" + ASkyBlockAPI.getInstance().getLongIslandLevel(island.getOwner()));
            boolean isBlockade = island.isLocked();
            if (isBlockade) {
                lore.add(" §7岛屿状态: §c封锁");
            } else {
                lore.add(" §7岛屿状态: §a开放");
            }
            lore.add(" §7岛屿成员:");
            List<UUID> uuidList = island.getMembers();
            for (UUID uuid : uuidList) {
                String name = PlayerManage.getUuidToName(uuid.toString());
                lore.add(" §f - " + name);
            }
            lore.add("§r");
            lore.add("§6▸ §e点击传送");
            meta.setLore(lore);
            item.setItemMeta(meta);
            NBTItem nbtItem = new NBTItem(item);
            nbtItem.setString("warpKey", wData.getKey());
            nbtItem.setBoolean("warpLock", isBlockade);
            return nbtItem.getItem();
        }
        return null;
    }
}
